#ifndef _H_08355E2FDD6D8D976F470BF9553FC06E_ControlDiagnostic__H_
#define _H_08355E2FDD6D8D976F470BF9553FC06E_ControlDiagnostic__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "autoware_auto_msgs/msg/dds_opensplice/DiagnosticHeader_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ControlDiagnostic_
            {
                ::autoware_auto_msgs::msg::dds_::DiagnosticHeader_ header_;
                ::DDS::Boolean new_trajectory_;
                ::DDS::String_mgr trajectory_source_;
                ::DDS::String_mgr pose_source_;
                ::DDS::Float lateral_error_m_;
                ::DDS::Float longitudinal_error_m_;
                ::DDS::Float velocity_error_mps_;
                ::DDS::Float acceleration_error_mps2_;
                ::DDS::Float yaw_error_rad_;
                ::DDS::Float yaw_rate_error_rps_;
            };

            typedef DDS_DCPSStruct_var<ControlDiagnostic_> ControlDiagnostic__var;
            typedef DDS_DCPSStruct_out < ControlDiagnostic_> ControlDiagnostic__out;

        }

    }

}

#endif /* _H_08355E2FDD6D8D976F470BF9553FC06E_ControlDiagnostic__H_ */
