#ifndef _H_D1B6AD469C2C855C6AEC2EA85C8675A0_VehicleOdometry_DCPS_H_
#define _H_D1B6AD469C2C855C6AEC2EA85C8675A0_VehicleOdometry_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleOdometry_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleOdometry_TypeSupportInterface;

            typedef VehicleOdometry_TypeSupportInterface * VehicleOdometry_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleOdometry_TypeSupportInterface> VehicleOdometry_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleOdometry_TypeSupportInterface> VehicleOdometry_TypeSupportInterface_out;


            class VehicleOdometry_DataWriter;

            typedef VehicleOdometry_DataWriter * VehicleOdometry_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleOdometry_DataWriter> VehicleOdometry_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleOdometry_DataWriter> VehicleOdometry_DataWriter_out;


            class VehicleOdometry_DataReader;

            typedef VehicleOdometry_DataReader * VehicleOdometry_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleOdometry_DataReader> VehicleOdometry_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleOdometry_DataReader> VehicleOdometry_DataReader_out;


            class VehicleOdometry_DataReaderView;

            typedef VehicleOdometry_DataReaderView * VehicleOdometry_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleOdometry_DataReaderView> VehicleOdometry_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleOdometry_DataReaderView> VehicleOdometry_DataReaderView_out;

            struct VehicleOdometry_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleOdometry_, struct VehicleOdometry_Seq_uniq_> VehicleOdometry_Seq;
            typedef DDS_DCPSSequence_var < VehicleOdometry_Seq> VehicleOdometry_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleOdometry_Seq> VehicleOdometry_Seq_out;

            class  VehicleOdometry_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleOdometry_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleOdometry_TypeSupportInterface_var _var_type;

                static VehicleOdometry_TypeSupportInterface_ptr _duplicate (VehicleOdometry_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleOdometry_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleOdometry_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleOdometry_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleOdometry_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleOdometry_TypeSupportInterface () {};
                ~VehicleOdometry_TypeSupportInterface () {};
            private:
                VehicleOdometry_TypeSupportInterface (const VehicleOdometry_TypeSupportInterface &);
                VehicleOdometry_TypeSupportInterface & operator = (const VehicleOdometry_TypeSupportInterface &);
            };

            class  VehicleOdometry_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleOdometry_DataWriter_ptr _ptr_type;
                typedef VehicleOdometry_DataWriter_var _var_type;

                static VehicleOdometry_DataWriter_ptr _duplicate (VehicleOdometry_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleOdometry_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleOdometry_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleOdometry_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleOdometry_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleOdometry_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleOdometry_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleOdometry_& instance_data) = 0;

            protected:
                VehicleOdometry_DataWriter () {};
                ~VehicleOdometry_DataWriter () {};
            private:
                VehicleOdometry_DataWriter (const VehicleOdometry_DataWriter &);
                VehicleOdometry_DataWriter & operator = (const VehicleOdometry_DataWriter &);
            };

            class  VehicleOdometry_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleOdometry_DataReader_ptr _ptr_type;
                typedef VehicleOdometry_DataReader_var _var_type;

                static VehicleOdometry_DataReader_ptr _duplicate (VehicleOdometry_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleOdometry_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleOdometry_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleOdometry_& instance) = 0;

            protected:
                VehicleOdometry_DataReader () {};
                ~VehicleOdometry_DataReader () {};
            private:
                VehicleOdometry_DataReader (const VehicleOdometry_DataReader &);
                VehicleOdometry_DataReader & operator = (const VehicleOdometry_DataReader &);
            };

            class  VehicleOdometry_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleOdometry_DataReaderView_ptr _ptr_type;
                typedef VehicleOdometry_DataReaderView_var _var_type;

                static VehicleOdometry_DataReaderView_ptr _duplicate (VehicleOdometry_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleOdometry_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleOdometry_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleOdometry_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleOdometry_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleOdometry_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleOdometry_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleOdometry_& instance) = 0;

            protected:
                VehicleOdometry_DataReaderView () {};
                ~VehicleOdometry_DataReaderView () {};
            private:
                VehicleOdometry_DataReaderView (const VehicleOdometry_DataReaderView &);
                VehicleOdometry_DataReaderView & operator = (const VehicleOdometry_DataReaderView &);
            };
        }

    }

}

#endif
