#ifndef _H_FAE65F2AA8C07A26D1444A8E97440B63_Quaternion32_DCPS_H_
#define _H_FAE65F2AA8C07A26D1444A8E97440B63_Quaternion32_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Quaternion32_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Quaternion32_TypeSupportInterface;

            typedef Quaternion32_TypeSupportInterface * Quaternion32_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Quaternion32_TypeSupportInterface> Quaternion32_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Quaternion32_TypeSupportInterface> Quaternion32_TypeSupportInterface_out;


            class Quaternion32_DataWriter;

            typedef Quaternion32_DataWriter * Quaternion32_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Quaternion32_DataWriter> Quaternion32_DataWriter_var;
            typedef DDS_DCPSInterface_out < Quaternion32_DataWriter> Quaternion32_DataWriter_out;


            class Quaternion32_DataReader;

            typedef Quaternion32_DataReader * Quaternion32_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Quaternion32_DataReader> Quaternion32_DataReader_var;
            typedef DDS_DCPSInterface_out < Quaternion32_DataReader> Quaternion32_DataReader_out;


            class Quaternion32_DataReaderView;

            typedef Quaternion32_DataReaderView * Quaternion32_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Quaternion32_DataReaderView> Quaternion32_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Quaternion32_DataReaderView> Quaternion32_DataReaderView_out;

            struct Quaternion32_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Quaternion32_, struct Quaternion32_Seq_uniq_> Quaternion32_Seq;
            typedef DDS_DCPSSequence_var < Quaternion32_Seq> Quaternion32_Seq_var;
            typedef DDS_DCPSSequence_out < Quaternion32_Seq> Quaternion32_Seq_out;

            class  Quaternion32_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Quaternion32_TypeSupportInterface_ptr _ptr_type;
                typedef Quaternion32_TypeSupportInterface_var _var_type;

                static Quaternion32_TypeSupportInterface_ptr _duplicate (Quaternion32_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Quaternion32_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Quaternion32_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Quaternion32_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Quaternion32_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Quaternion32_TypeSupportInterface () {};
                ~Quaternion32_TypeSupportInterface () {};
            private:
                Quaternion32_TypeSupportInterface (const Quaternion32_TypeSupportInterface &);
                Quaternion32_TypeSupportInterface & operator = (const Quaternion32_TypeSupportInterface &);
            };

            class  Quaternion32_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Quaternion32_DataWriter_ptr _ptr_type;
                typedef Quaternion32_DataWriter_var _var_type;

                static Quaternion32_DataWriter_ptr _duplicate (Quaternion32_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Quaternion32_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Quaternion32_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Quaternion32_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Quaternion32_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Quaternion32_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Quaternion32_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Quaternion32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Quaternion32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Quaternion32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Quaternion32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Quaternion32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Quaternion32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Quaternion32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Quaternion32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Quaternion32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Quaternion32_& instance_data) = 0;

            protected:
                Quaternion32_DataWriter () {};
                ~Quaternion32_DataWriter () {};
            private:
                Quaternion32_DataWriter (const Quaternion32_DataWriter &);
                Quaternion32_DataWriter & operator = (const Quaternion32_DataWriter &);
            };

            class  Quaternion32_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Quaternion32_DataReader_ptr _ptr_type;
                typedef Quaternion32_DataReader_var _var_type;

                static Quaternion32_DataReader_ptr _duplicate (Quaternion32_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Quaternion32_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Quaternion32_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Quaternion32_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Quaternion32_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Quaternion32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Quaternion32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Quaternion32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Quaternion32_& instance) = 0;

            protected:
                Quaternion32_DataReader () {};
                ~Quaternion32_DataReader () {};
            private:
                Quaternion32_DataReader (const Quaternion32_DataReader &);
                Quaternion32_DataReader & operator = (const Quaternion32_DataReader &);
            };

            class  Quaternion32_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Quaternion32_DataReaderView_ptr _ptr_type;
                typedef Quaternion32_DataReaderView_var _var_type;

                static Quaternion32_DataReaderView_ptr _duplicate (Quaternion32_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Quaternion32_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Quaternion32_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Quaternion32_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Quaternion32_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Quaternion32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Quaternion32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Quaternion32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Quaternion32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Quaternion32_& instance) = 0;

            protected:
                Quaternion32_DataReaderView () {};
                ~Quaternion32_DataReaderView () {};
            private:
                Quaternion32_DataReaderView (const Quaternion32_DataReaderView &);
                Quaternion32_DataReaderView & operator = (const Quaternion32_DataReaderView &);
            };
        }

    }

}

#endif
